all: disk.img

CAT?=	cat
RM?=	rm -f
GHC?=	ghc
CC?=	clang --target=x86_64-elf
QEMU?=	qemu-system-x86_64

CFLAGS=-static -fno-strict-aliasing -ffreestanding -fno-stack-protector \
	-fno-stack-check -fomit-frame-pointer -fno-asynchronous-unwind-tables \
	-mno-red-zone -nostdlib -Wall -Wextra -Werror \
	-Oz -fno-optimize-sibling-calls \
	-fno-function-sections -z max-page-size=0x10 -mcmodel=small
LDFLAGS=-Wl,-Ttext=0x100000 -Wl,--build-id=none -Wl,--gc-sections

program.c: Program.lhs Main.lhs QuasiC.lhs
	$(GHC) Main.lhs
	./Main > program.c

program.elf: program.c
	$(CC) -s $(CFLAGS) $(LDFLAGS) program.c -o program.elf

program.s: program.c
	$(CC) -S $(CFLAGS) program.c -o program.s

disk.img: boot_elf.bin program.elf
	$(CAT) boot_elf.bin program.elf > disk.img

.PHONY: run clean

clean:
	$(RM) program.s program.c program.elf Main *.o *.hi disk.img

run: disk.img
	$(QEMU) -drive file=disk.img,format=raw,index=0,media=disk
